<?php

class TwitterSearch
{
	protected $encoded_query;
	protected $search_url;
	protected $max_tweets;
	protected $tweets;

	public function __construct( $query, $max_tweets )
	{
		$this->load_magpie();
		$this->construct_search_url( $query );
		$this->max_tweets = $max_tweets;
	}

	public function tweets()
	{
		$this->do_search();
		return (array) $this->tweets;
	}
	
	protected function construct_search_url( $query )
	{
		// Effing slashes
		$query = stripslashes( $query );
		// URL encode query
		$this->encoded_query = urlencode( $query );
		$base_url = 'http://search.twitter.com/search.atom?q=';
		$this->search_url = $base_url . $this->encoded_query;
	}
	
	protected function do_search()
	{
		// N.B. Cache is implemented by Magpie. Phew.
		$rss = @ fetch_rss( $this->search_url );
		
		if ( is_array( $rss->items ) && ! empty( $rss->items ) ) {
			// Retrieve number of tweets from the options
			$max_items = (int) @ $this->max_tweets;
			if ( ! $max_items ) $max_items = 3;
			$rss->items = array_slice( $rss->items, 0, $max_items );

			// loop through each item in the feed
			foreach( $rss->items as & $item ){
				$this->tweets[] = new Tweet(
						$item[ 'atom_content' ],
						$item[ 'link' ],
						$item[ 'published' ],
						$item[ 'author_name' ],
						$item[ 'author_uri' ],
						$item[ 'link_image' ]
					);
			}
		}
	}
	
	protected function load_magpie()
	{
		if (function_exists('fetch_rss')) return true;

		$wp_includes = ABSPATH . WPINC;
		if ( file_exists( $wp_includes . '/rss.php' ) ) {
			require_once( $wp_includes . '/rss.php');
		} elseif ( file_exists( $wp_includes . '/rss-functions.php' ) ) {
			require_once(  $wp_includes . '/rss-functions.php' );
		}

		if ( function_exists( 'fetch_rss' ) ) return true;
		return false;
	}
}

?>